package ntp;

import java.rmi.Naming; 
import java.rmi.RemoteException; 
import java.rmi.RMISecurityManager;
import java.util.Date;

public class NTPClient {
    
    public static void main(String args[]) {
	
	if (args.length != 1) {
            System.out.println("Usage: java cristian.NTPClient host");
            System.exit(1); 
        }

	// Create and install a security manager 
        System.setSecurityManager(new RMISecurityManager()); 
	
	try { 
            // "obj" is the identifier that we'll use to refer 
            // to the remote object that implements the "NTP" interface 
	    NTP obj = (NTP)Naming.lookup("rmi://" + args[0] + "/NTPServer");

            // Here we go...
            Date Date1 = new Date();
            Date Date2 = obj.getDate();
            Date Date3 = obj.getDate();
            Date Date4 = new Date();

            long t1 = Date1.getTime();
            long t2 = Date2.getTime();
            long t3 = Date3.getTime();
            long t4 = Date4.getTime();

            System.out.println("Time 1 is " + Date1 + " (" + t1 + " ms)");
            System.out.println("Time 2 is " + Date2 + " (" + t2 + " ms)");
            System.out.println("Time 3 is " + Date3 + " (" + t3 + " ms)");
            System.out.println("Time 4 is " + Date4 + " (" + t4 + " ms)");
 
            long d = (t4 - t1) - (t3 - t2);
            System.out.println("d is " + d + " ms");

            long theta = (t2 - t1 + t3 - t4) / 2;
            System.out.println("Clock skew (Theta) is " + theta + " ms");
            System.out.println("Accuracy is +/-" + d/2 + " ms");
	} catch (Exception e) { 
	    System.out.println("NTPClient exception: " + e.getMessage()); 
	    e.printStackTrace(); 
	} 
    }
}
