package ntp;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;
import java.rmi.server.UnicastRemoteObject;
import java.util.Date;

public class NTPImpl extends UnicastRemoteObject
    implements NTP {

    public NTPImpl() throws RemoteException {
        super();
    }

    public Date getDate() {
        return new Date();
    }

    public static void main(String args[]) { 

        // Create and install a security manager 
        System.setSecurityManager(new RMISecurityManager()); 

        try { 
	    NTP obj = new NTPImpl(); 
	    // Bind this object instance to the name "NTPServer" 
	    // Naming.rebind("rmi://localhost/NTPServer", obj); 
	    Naming.rebind("NTPServer", obj); 
	    System.out.println("NTPServer bound in registry"); 
        } catch (Exception e) { 
	    System.out.println("NTPImpl exception: " + e.getMessage()); 
	    e.printStackTrace(); 
        } 
    } 
}
